@echo off
goto :BEGIN


	sagetv-backup.cmd

	REF: http://forums.sagetv.com/forums/showthread.php?t=43497

:SYNTAX
	cd /d %~DP0
	echo.
	echo 	SYNTAX: SAGETV-BACKUP (CONFIG ^| MANUAL ^| WEEKLY )
	echo.
	echo 		CONFIG: Backup just SageTV configuration files
	echo 		WEEKLY: Full backup of SageTV
	echo 		MANUAL: Full backup of SageTV (version stamped)
	echo.
	set /P PARAM1=Enter the SageTV backup method you would like to run now: 
	if "%PARAM1%"=="" goto :EOF
	%~N0 %PARAM1%
	goto :EOF

:BEGIN
	SETLOCAL EnableDelayedExpansion 
	CLS

	if "%1"=="" goto :SYNTAX
	call :UPCASE %1

:: **********************************************************************************
::    Configure the SET variables and pathnames locations below to match your setup. 
:: **********************************************************************************

:: SageTVDir = your SageTV install directory
SET SageTVDir=C:\Program Files\SageTV

:: Set numFiles equal to the number of files you have manually defined.
:: Leave it at 0 to have the script ignore the #file definitions.
:: If it's set to 1 it will read the 1file variables and ignore the rest, if it's set
:: to 2 it will read the 1file and 2file variables and ignore the rest, and so on.
:: Set each #filePath line equal to the full pathname of the source file and set
:: each #fileDestination line equal to the directory name that the file will be
:: located in within the backup zip.
:: There are 3 sample file definitions below.  You can add as many
:: additional items as you need, just be sure they are sequentially
:: numbered and the total number is correctly defined by the numFiles.
:: Files defined will be copied from #filePath to #fileDestination.

SET numFiles=1

SET 1filePath=c:\Program Files\SageTV\SageTV\*.frq
SET 1fileDestination=SageTV

:: WEBFEED ENCODER: http://forums.sagetv.com/forums/showthread.php?t=40637
SET 2filePath=c:\Program Files\SageTV\webfeedencoder\config\*.*
SET 2fileDestination=webfeedencoder\config

:: Set numDirs equal to the number of directories you have manually defined.
:: Leave it at 0 to have the script ignore the #dir definitions.
:: If it's set to 1 it will read the 1dir variables and ignore the rest, if it's set
:: to 2 it will read the 1file and 2dir variables and ignore the rest, and so on.
:: Set each #dirPath line equal to the full pathname of the source directory and set
:: each #dirDestination line equal to the directory name that the directory will be
:: located in within the backup zip.
:: There are 3 sample directory definitions below.  You can add as many
:: additional items as you need, just be sure they are sequentially
:: numbered and the total number is correctly defined by the numDirs.
:: Directories defined will be xcopied from #dirPath to #dirDestination.
:: Xcopied means the entire source directory structure including files and 
:: subdirectories will be copied.

SET numDirs=0

SET 1dirPath=c:\Program Files\SageTV\webfeedencoder
SET 1dirDestination=webfeedencoder

SET 2dirPath=c:\full\path\to\directory2
SET 2dirDestination=Destination Backup Directory

SET 3dirPath=c:\etc\etc\etc\directory7
SET 3dirDestination=Destination Backup Directory

	goto :%PARAM1%

:CONFIG

:: DaysToKeep = # of daily config backups to keep. 
:: Anything older will be automatically deleted.
SET DaysToKeep=14

	goto :SET%PARAM1%


:WEEKLY

:: DaysToKeep = (# of weeks to keep) x 7
:: Anything older will be automatically deleted.
SET DaysToKeep=28

	goto :SET%PARAM1%


:MANUAL

	goto :SET%PARAM1%


:: **********************************************************************************
::    End of Configuration.  You shouldn't need to change anything below this point.
:: **********************************************************************************


:SETCONFIG
	SET backupDirTemp=%TEMP%\Config (daily auto backups)
	CALL :GETDATE
	SET folderName=SageTV Config Backup (%date%)
	goto :PROCESS

:SETWEEKLY	
	SET backupDirTemp=%TEMP%\Full (weekly auto backups)
	CALL :GETDATE
	SET folderName=SageTV Full Backup (%date%)
	goto :PROCESS

:SETMANUAL
	SET backupDirTemp=%Temp%\Full (manual backups)

	:: Extract SageTV version from registry
	:: HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Installer\UserData\S-1-5-18\Products\F5CF942D133B1C747A31CE8714DA8D6F\InstallProperties\[DisplayVersion]
	::This will give you a zip file named: SageTV v6.6.1 Backup (mm-dd-yyyy).zip
	set SageVer=
	regedit.exe /e "%TEMP%\SageVer.reg" "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Installer\UserData\S-1-5-18\Products\F5CF942D133B1C747A31CE8714DA8D6F\InstallProperties"
	for /f "tokens=2 delims==" %%A in ('type "%TEMP%\SageVer.reg" ^| find "DisplayVersion"') do set SageVer=%%A
	set SageVer=%Sagever:~1,-1%
	echo SageTV Version is %SageVer%

	CALL :GETDATE
	SET folderName=SageTV_%SageVer% Backup (%date%)
	goto :PROCESS


:PROCESS
	path=%~DP0;%PATH%
	TITLE=%~N0 %PARAM1%
	ECHO Setting temp folder name = !folderName!

	:: windowsDir = where the irremote.ini file is stored (not everybody has or needs this)
	SET windowsDir=%WINDIR%

	CD /D "%~DP0"

	echo %yyyy%-%mm%-%dd% %hr%:%min%:%ampm% SageTV %PARAM1% Backup >> "%SageTV Backups.log"
	if NOT EXIST "%backupDirTemp%\%folderName%" MKDIR "%backupDirTemp%\%folderName%"
	goto :GO%PARAM1%

:GOCONFIG
	ECHO Backing up RemoteCodes...
	if NOT EXIST "%backupDirTemp%\%folderName%\Common\RemoteCodes" MKDIR "%backupDirTemp%\%folderName%\Common\RemoteCodes"
	XCOPY "%SageTVDir%\Common\RemoteCodes" "%backupDirTemp%\%folderName%\Common\RemoteCodes" /e /q

	ECHO Backing up SageTV database and properties...
	if NOT EXIST "%backupDirTemp%\%folderName%\SageTV\clients" MKDIR "%backupDirTemp%\%folderName%\SageTV\clients"
	COPY "%SageTVDir%\SageTV\Wiz.bin" "%backupDirTemp%\%folderName%\SageTV" >nul
	COPY "%SageTVDir%\SageTV\Wiz.bak" "%backupDirTemp%\%folderName%\SageTV" >nul
	COPY "%SageTVDir%\SageTV\Sage.properties" "%backupDirTemp%\%folderName%\SageTV" >nul
	COPY "%SageTVDir%\SageTV\Sage.properties.autobackup" "%backupDirTemp%\%folderName%\SageTV" >nul
	COPY "%SageTVDir%\SageTV\SageClient.properties" "%backupDirTemp%\%folderName%\SageTV" >nul
	COPY "%SageTVDir%\SageTV\SageClient.properties.autobackup" "%backupDirTemp%\%folderName%\SageTV" >nul
	XCOPY "%SageTVDir%\SageTV\clients" "%backupDirTemp%\%folderName%\SageTV\clients" /e /q >nul
	goto :GOCOMMON


:GOMANUAL
:GOWEEKLY
	ECHO Backing up SageTV Common directory...
	if NOT EXIST "%backupDirTemp%\%folderName%\Common" MKDIR "%backupDirTemp%\%folderName%\Common"
	XCOPY "%SageTVDir%\Common" "%backupDirTemp%\%folderName%\Common" /e /q >nul

	ECHO Backing up SageTV directory...
	if NOT EXIST "%backupDirTemp%\%folderName%\SageTV" MKDIR "%backupDirTemp%\%folderName%\SageTV"
	XCOPY "%SageTVDir%\SageTV" "%backupDirTemp%\%folderName%\SageTV" /e /q >nul
	goto :GOCOMMON

:GOCOMMON
	ECHO Backing up Irremote.ini file...
	COPY "%windowsDir%\Irremote.ini" "%backupDirTemp%\%folderName%" >nul

	IF NOT %numFiles%==0 ECHO Backing up manually defined files... 
	FOR /L %%G IN (1,1,%numFiles%) DO (
	IF EXIST "!%%GfilePath!" (ECHO ...Backing up !%%GfilePath!
	if NOT EXIST "%backupDirTemp%\%folderName%\!%%GfileDestination!" MKDIR "%backupDirTemp%\%folderName%\!%%GfileDestination!"
	COPY "!%%GfilePath!" "%backupDirTemp%\%folderName%\!%%GfileDestination!" >nul ) ELSE (
	ECHO ...!%%GfilePath! was not found. Moving on...
	))

	IF NOT %numDirs%==0 ECHO Backing up manually defined directories...
	FOR /L %%G IN (1,1,%numDirs%) DO (
	IF EXIST "!%%GdirPath!\*" (ECHO ...Backing up !%%GdirPath!
	if NOT EXIST "%backupDirTemp%\%folderName%\!%%GdirDestination!" MKDIR "%backupDirTemp%\%folderName%\!%%GdirDestination!"
	XCOPY "!%%GdirPath!" "%backupDirTemp%\%folderName%\!%%GdirDestination!" /e /q >nul ) ELSE (
	ECHO ...!%%GdirPath! was not found. Moving on...
	))

	ECHO Cleaning up old backups...
	if NOT "%DaysToKeep%"=="" FORFILES /p "%~DP0" /m "SageTV *.zip" /d -%DaysToKeep% /c "cmd /c del @path" > nul

	ECHO Compressing backup: %folderName%
	CD /D "%backupDirTemp%\%folderName%"
	"%~DP0\zip.exe" -r -9 -q -S "%~DP0\%folderName%".zip *.*
	CD /D "%~DP0"

	ECHO Keeping compressed backup...
	ECHO Deleting backup directory: %folderName%
	if EXIST "%~DP0\%folderName%".zip RD /s /q "%backupDirTemp%\%folderName%"
	if NOT EXIST "%~DP0\%folderName%".zip goto :ERROR
	goto :END%PARAM1%

:ENDCONFIG
	ECHO Config backup for %date% complete.
	goto :DONE

:ENDWEEKLY
	ECHO Full WEEKLY backup for %date% complete.
	goto :DONE

:ENDMANUAL
	ECHO Full MANUAL backup for %date% complete.
	goto :DONE

:DONE
	if EXIST postbackup.cmd postbackup.cmd %PARAM1% "%FolderName%"
	goto :EOF

:GETDATE
	FOR /F "TOKENS=1* DELIMS= " %%A IN ('DATE/T') DO SET CDATE=%%B
	FOR /F "TOKENS=1,2 eol=/ DELIMS=/ " %%A IN ('DATE/T') DO SET mm=%%B
	FOR /F "TOKENS=1,2 DELIMS=/ eol=/" %%A IN ('echo %CDATE%') DO SET dd=%%B
	FOR /F "TOKENS=2,3 DELIMS=/ " %%A IN ('echo %CDATE%') DO SET yyyy=%%B
	FOR /F "TOKENS=1* DELIMS= " %%A IN ('TIME/T') DO SET ampm=%%B
	FOR /F "TOKENS=1* DELIMS= " %%A IN ('TIME/T') DO SET CTIME=%%A
	FOR /F "TOKENS=1,2 eol=/ DELIMS=: " %%A IN ('TIME/T') DO SET hr=%%A
	FOR /F "TOKENS=1,2 DELIMS=: " %%A IN ('echo %CTIME%') DO SET min=%%B
	SET date=%mm%-%dd%-%yyyy% %hr%%min%%ampm%
	goto :EOF

:UPCASE
	SET _UCase=A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
	SET UCase_Tmp=%1
	FOR %%Z IN (%_UCase%) DO SET UCase_Tmp=!UCase_Tmp:%%Z=%%Z!
	SET PARAM1=%UCase_Tmp%
	goto :EOF

:ERROR
	echo.
	echo Failed to create %~DP0\%folderName%.zip!
	echo Out of disk space?
	echo.
	dir "%~DP0\*.zip"
	echo.
	pause
