@echo off
goto :BEGIN


	sagetv-config-backup.cmd

	REF: http://forums.sagetv.com/forums/showthread.php?t=43497


:BEGIN

SETLOCAL EnableDelayedExpansion 
CLS

:: *****************************************************************
::    Configure the SET variables and pathnames locations below to match your setup. 
:: *****************************************************************
path=%~DP0;%PATH%
TITLE=%~N0

:: DaysToKeep = # of daily config backups to keep. 
:: Anything older will be automatically deleted.
SET DaysToKeep=14

:: SageTVDir = your SageTV install directory
SET SageTVDir=C:\Program Files\SageTV

:: backupDirTemp = where you want the backup .zip files for weekly backups stored
SET backupDirTemp=%TEMP%\Config (daily auto backups)

:: windowsDir = where the irremote.ini file is stored (not everybody has or needs this)
SET windowsDir=%WINDIR%

:: Set numFiles equal to the number of files you have manually defined.
:: Leave it at 0 to have the script ignore the #file definitions.
:: If it's set to 1 it will read the 1file variables and ignore the rest, if it's set
:: to 2 it will read the 1file and 2file variables and ignore the rest, and so on.
:: Set each #filePath line equal to the full pathname of the source file and set
:: each #fileDestination line equal to the directory name that the file will be
:: located in within the backup zip.
:: There are 3 sample file definitions below.  You can add as many
:: additional items as you need, just be sure they are sequentially
:: numbered and the total number is correctly defined by the numFiles.
:: Files defined will be copied from #filePath to #fileDestination.

SET numFiles=1

SET 1filePath=c:\Program Files\SageTV\SageTV\*.frq
SET 1fileDestination=SageTV

:: WEBFEED ENCODER: http://forums.sagetv.com/forums/showthread.php?t=40637
SET 2filePath=c:\Program Files\SageTV\webfeedencoder\config\*.*
SET 2fileDestination=webfeedencoder\config


:: Set numDirs equal to the number of directories you have manually defined.
:: Leave it at 0 to have the script ignore the #dir definitions.
:: If it's set to 1 it will read the 1dir variables and ignore the rest, if it's set
:: to 2 it will read the 1file and 2dir variables and ignore the rest, and so on.
:: Set each #dirPath line equal to the full pathname of the source directory and set
:: each #dirDestination line equal to the directory name that the directory will be
:: located in within the backup zip.
:: There are 3 sample directory definitions below.  You can add as many
:: additional items as you need, just be sure they are sequentially
:: numbered and the total number is correctly defined by the numDirs.
:: Directories defined will be xcopied from #dirPath to #dirDestination.
:: Xcopied means the entire source directory structure including files and 
:: subdirectories will be copied.

SET numDirs=0

SET 1dirPath=c:\Program Files\SageTV\webfeedencoder
SET 1dirDestination=webfeedencoder

SET 2dirPath=c:\full\path\to\directory2
SET 2dirDestination=Destination Backup Directory

SET 3dirPath=c:\etc\etc\etc\directory7
SET 3dirDestination=Destination Backup Directory

:: ****************************************************************
::    End of Configuration.  You shouldn't need to change anything below this point.
:: ****************************************************************

CD /D "%~DP0"

FOR /F "TOKENS=1* DELIMS= " %%A IN ('DATE/T') DO SET CDATE=%%B
FOR /F "TOKENS=1,2 eol=/ DELIMS=/ " %%A IN ('DATE/T') DO SET mm=%%B
FOR /F "TOKENS=1,2 DELIMS=/ eol=/" %%A IN ('echo %CDATE%') DO SET dd=%%B
FOR /F "TOKENS=2,3 DELIMS=/ " %%A IN ('echo %CDATE%') DO SET yyyy=%%B
FOR /F "TOKENS=1* DELIMS= " %%A IN ('TIME/T') DO SET ampm=%%B
FOR /F "TOKENS=1* DELIMS= " %%A IN ('TIME/T') DO SET CTIME=%%A
FOR /F "TOKENS=1,2 eol=/ DELIMS=: " %%A IN ('TIME/T') DO SET hr=%%A
FOR /F "TOKENS=1,2 DELIMS=: " %%A IN ('echo %CTIME%') DO SET min=%%B
SET date=%mm%-%dd%-%yyyy% %hr%%min%%ampm%
SET folderName=SageTV Config Backup (%date%)

MKDIR "%backupDirTemp%\%folderName%"

ECHO Backing up RemoteCodes...
MKDIR "%backupDirTemp%\%folderName%\Common\RemoteCodes"
XCOPY "%SageTVDir%\Common\RemoteCodes" "%backupDirTemp%\%folderName%\Common\RemoteCodes" /e /q

ECHO Backing up SageTV database and properties...
MKDIR "%backupDirTemp%\%folderName%\SageTV"
MKDIR "%backupDirTemp%\%folderName%\SageTV\clients"
COPY "%SageTVDir%\SageTV\Wiz.bin" "%backupDirTemp%\%folderName%\SageTV"
COPY "%SageTVDir%\SageTV\Wiz.bak" "%backupDirTemp%\%folderName%\SageTV"
COPY "%SageTVDir%\SageTV\Sage.properties" "%backupDirTemp%\%folderName%\SageTV"
COPY "%SageTVDir%\SageTV\Sage.properties.autobackup" "%backupDirTemp%\%folderName%\SageTV"
COPY "%SageTVDir%\SageTV\SageClient.properties" "%backupDirTemp%\%folderName%\SageTV"
COPY "%SageTVDir%\SageTV\SageClient.properties.autobackup" "%backupDirTemp%\%folderName%\SageTV"
XCOPY "%SageTVDir%\SageTV\clients" "%backupDirTemp%\%folderName%\SageTV\clients" /e /q

ECHO Backing up Irremote.ini file...
COPY "%windowsDir%\Irremote.ini" "%backupDirTemp%\%folderName%"

IF NOT %numFiles%==0 ECHO Backing up manually defined files... 
FOR /L %%G IN (1,1,%numFiles%) DO (
IF EXIST "!%%GfilePath!" (ECHO ...Backing up !%%GfilePath!
MKDIR "%backupDirTemp%\%folderName%\!%%GfileDestination!"
COPY "!%%GfilePath!" "%backupDirTemp%\%folderName%\!%%GfileDestination!" ) ELSE (
ECHO ...!%%GfilePath! was not found. Moving on...
))

IF NOT %numDirs%==0 ECHO Backing up manually defined directories...
FOR /L %%G IN (1,1,%numDirs%) DO (
IF EXIST "!%%GdirPath!\*" (ECHO ...Backing up !%%GdirPath!
MKDIR "%backupDirTemp%\%folderName%\!%%GdirDestination!"
XCOPY "!%%GdirPath!" "%backupDirTemp%\%folderName%\!%%GdirDestination!" /e /q ) ELSE (
ECHO ...!%%GdirPath! was not found. Moving on...
))

ECHO Cleaning up old backups...
if NOT "%DaysToKeep%"=="" FORFILES /p "%~DP0" /m "SageTV *.zip" /d -%DaysToKeep% /c "cmd /c del @path" > nul

ECHO Compressing backup: %folderName%
CD /D "%backupDirTemp%\%folderName%"
"%~DP0\zip.exe" -r -9 -q -S "%~DP0\%folderName%".zip *.*
CD /D "%~DP0"

ECHO Keeping compressed backup...
ECHO Deleting backup directory: %folderName%
RD /s /q "%backupDirTemp%\%folderName%"

ECHO Config backup for %date% complete.
